//
// ANSI box/window routines for T42 Software development
// (c) June 1993, by Kevin Phillips
//

#include "globals.h"

//
// Clear the screen entirely
// using the selected attribute
//

void cls(att)
char att;
{
	 char i,j;
	 char far *scrn;

	 for (i=24; i>=0; i--)
		for (j=79; j>=0; j--){
			scrn = vidmem + (j*2) + (i*160);
			*scrn++=32;
			*scrn=att;
			}
}



//
// Make window details by inserting correct details
//

void make(n,title,x,y,max,s,a,b,menu,num)
char n,x,y,s,max,a,b,num;
char *menu[];
char title[];
{
	int size;
	char w,h,i,len;
	unsigned char *buff;

	// First, Calculate the size of the window from Menu details

	h=(num+1);

	len=strlen(title);
	for (i=0; i<max; i++)
		if (strlen(menu[i]) > len )
			len = strlen(menu[i]);

	w=(len+1);

	size = ((w+2)*(h+2)) * 2;
	buff = (unsigned char *) malloc (size);
	if (!buff) {
		printf ("Not enough memory left I am afraid !");
		exit (1);
		}

	ansibox[n].x = x;  			// Top x
	ansibox[n].y = y;  			// Top y
	ansibox[n].h = h;  			// Height of window
	ansibox[n].w = w; 			// Width of window
	ansibox[n].p = buff; 			// Storage area for background
	ansibox[n].s = s;      			// Shadow (0 - No, 1 - Yes)
	ansibox[n].att = a;     		// Attribute
	ansibox[n].menu = (char **) menu;	// Pointer to menu/text array
	ansibox[n].num = num;                   // Menu/text items displayed
	strcpy(ansibox[n].name,title);          // Title of menu
	ansibox[n].ptr = 0;                     // Pointer in menu
	ansibox[n].bdr = b;			// Border attribute
	ansibox[n].item = 0;			// Pointer to item in list
	ansibox[n].max = max;			// Maximum item no.

	if (max > num)
		ansibox[n].scroll = 1;
	else
		ansibox[n].scroll = 0;
}

//
// Store an area of the screen
// NB: This routine is called when a box is opened,
// so should not need to be called upon by itself.
//

void copysc (nm)
char nm;
{

	char i,j,x,y,h,w;
	char far *scrn;
	unsigned char *p;

	x = ansibox[nm].x;			// Read in the details
	y = ansibox[nm].y;
	h = ansibox[nm].h;
	w = ansibox[nm].w;
	p = ansibox[nm].p;

	h++;					// +1 to border for shadow
	w++;                                    // details (wasteful!!)

	for (i=0; i<=h; i++)
		for (j=0; j<=w; j++) {
			scrn = vidmem + ((x+j)*2) + ((y+i)*160);

			*p++=*scrn++;
			*p++=*scrn;
			}
}

//
// Draw a Box at x,y
// with specified attribute and SINGLE line border.
//

void std_box (sx,sy,w,h,att)
char sx,sy,h,w,att;
{

	char i,j;
	char far *scrn;

	for (i=1; i<w; i++) 				// First clear inside box
		for (j=1; j<h; j++){
		   scrn = vidmem + ((sx+i)*2) + ((sy+j)*160);
		   *scrn++=32;
		   *scrn=att;
		   }
	for (i=1; i<w; i++){                    	// Draw horizontals
		scrn = vidmem + ((sx+i)*2) + (sy*160);
		*scrn++=196;
		*scrn=att;
		scrn = vidmem + ((sx+i)*2) + ((sy+h)*160);
		*scrn++=196;
		*scrn=att;
		}
	for (i=1; i<h; i++){				// Draw verticals
		scrn = vidmem + (sx*2) + ((sy+i)*160);
		*scrn++=179;
		*scrn=att;
		scrn = vidmem + ((sx+w)*2) + ((sy+i)*160);
		*scrn++=179;
		*scrn=att;
		}

		scrn = vidmem + (sx*2) + (sy*160);	// Draw each corner
		*scrn++=218;
		*scrn=att;
		scrn = vidmem + (sx*2) + ((sy+h)*160);
		*scrn++=192;
		*scrn=att;
		scrn = vidmem + ((sx+w)*2) + (sy*160);
		*scrn++=191;
		*scrn=att;
		scrn = vidmem + ((sx+w)*2) + ((sy+h)*160);
		*scrn++=217;
		*scrn=att;
}

//
// Draw a predefined box with menu/text
// and title, plus shadow if requested
//

void open_box(num)
char num;
{

	char i,j,shadow,liststart,w,h,sx,sy,menum,att,atb;
	char **openmen;
	char far *scrn;
	char bufr[4];

	copysc (num);					// Store background

	sx = ansibox[num].x;				// Get details
	sy = ansibox[num].y;
	h = ansibox[num].h;
	w = ansibox[num].w;
	shadow = ansibox[num].s;
	att = ansibox[num].att;
	openmen = ansibox[num].menu;
	menum = ansibox[num].num;
	atb = ansibox[num].bdr;
	liststart = ansibox[num].item;

	if (!ansibox[num].scroll)
		liststart=0;
	else
		liststart=liststart - ansibox[num].ptr;

	for (i=1; i<w; i++)                         	// Again, draw as per std_box but with DOUBLE lines
		for (j=1; j<h; j++){
		   scrn = vidmem + ((sx+i)*2) + ((sy+j)*160);
		   *scrn++=32;
		   *scrn=att;
		   }
	for (i=1; i<w; i++){
		scrn = vidmem + ((sx+i)*2) + (sy*160);
		*scrn++=205;
		*scrn=atb;
		scrn = vidmem + ((sx+i)*2) + ((sy+h)*160);
		*scrn++=205;
		*scrn=atb;
		}
	for (i=1; i<h; i++){
		scrn = vidmem + (sx*2) + ((sy+i)*160);
		*scrn++=186;
		*scrn=atb;
		scrn = vidmem + ((sx+w)*2) + ((sy+i)*160);
		*scrn++=186;
		*scrn=atb;
		}

		scrn = vidmem + (sx*2) + (sy*160);
		*scrn++=201;
		*scrn=atb;
		scrn = vidmem + (sx*2) + ((sy+h)*160);
		*scrn++=200;
		*scrn=atb;
		scrn = vidmem + ((sx+w)*2) + (sy*160);
		*scrn++=187;
		*scrn=atb;
		scrn = vidmem + ((sx+w)*2) + ((sy+h)*160);
		*scrn++=188;
		*scrn=atb;

	if (shadow){					// Shadow using attributes

		for (i=0; i<=h; i++){
			scrn = vidmem + ((sx+w+1)*2) + ((sy+1+i)*160) + 1;
			*scrn=8;
			}

		for (i=0; i<=w; i++){
			scrn = vidmem + ((sx+1+i)*2) + ((sy+h+1)*160) + 1;
			*scrn=8;
			}
	}

	if (ansibox[num].scroll) {
		sprintf (bufr,"%c",30);
		wstring (sx+w,sy+1,atb,bufr);
		sprintf (bufr,"%c",31);
		wstring (sx+w,(sy+h)-1,atb,bufr);
		}

	for (i = liststart; i < (liststart+menum); i++)				// Print menu/text
		wstring (sx+1, (sy+1)+(i-liststart), att, openmen[i]);

	wstring (sx+1,sy,atb,ansibox[num].name);	// Print title

}

// Just draw the box again, not re-open (Storing background)

void draw_box(num)
char num;
{

	char i,j,shadow,liststart,w,h,sx,sy,menum,att,atb;
	char **openmen;
	char far *scrn;
	char bufr[4];

	sx = ansibox[num].x;				// Get details
	sy = ansibox[num].y;
	h = ansibox[num].h;
	w = ansibox[num].w;
	shadow = ansibox[num].s;
	att = ansibox[num].att;
	openmen = ansibox[num].menu;
	menum = ansibox[num].num;
	atb = ansibox[num].bdr;
	liststart = ansibox[num].item;

	if (!ansibox[num].scroll)
		liststart=0;
	else
		liststart=liststart - ansibox[num].ptr;

	for (i=1; i<w; i++)                         	// Again, draw as per std_box but with DOUBLE lines
		for (j=1; j<h; j++){
		   scrn = vidmem + ((sx+i)*2) + ((sy+j)*160);
		   *scrn++=32;
		   *scrn=att;
		   }
	for (i=1; i<w; i++){
		scrn = vidmem + ((sx+i)*2) + (sy*160);
		*scrn++=205;
		*scrn=atb;
		scrn = vidmem + ((sx+i)*2) + ((sy+h)*160);
		*scrn++=205;
		*scrn=atb;
		}
	for (i=1; i<h; i++){
		scrn = vidmem + (sx*2) + ((sy+i)*160);
		*scrn++=186;
		*scrn=atb;
		scrn = vidmem + ((sx+w)*2) + ((sy+i)*160);
		*scrn++=186;
		*scrn=atb;
		}

		scrn = vidmem + (sx*2) + (sy*160);
		*scrn++=201;
		*scrn=atb;
		scrn = vidmem + (sx*2) + ((sy+h)*160);
		*scrn++=200;
		*scrn=atb;
		scrn = vidmem + ((sx+w)*2) + (sy*160);
		*scrn++=187;
		*scrn=atb;
		scrn = vidmem + ((sx+w)*2) + ((sy+h)*160);
		*scrn++=188;
		*scrn=atb;

	if (shadow){					// Shadow using attributes

		for (i=0; i<=h; i++){
			scrn = vidmem + ((sx+w+1)*2) + ((sy+1+i)*160) + 1;
			*scrn=8;
			}

		for (i=0; i<=w; i++){
			scrn = vidmem + ((sx+1+i)*2) + ((sy+h+1)*160) + 1;
			*scrn=8;
			}
	}

	if (ansibox[num].scroll) {
		sprintf (bufr,"%c",30);
		wstring (sx+w,sy+1,atb,bufr);
		sprintf (bufr,"%c",31);
		wstring (sx+w,(sy+h)-1,atb,bufr);
		}

	for (i = liststart; i < (liststart+menum); i++)				// Print menu/text
		wstring (sx+1, (sy+1)+(i-liststart), att, openmen[i]);

	wstring (sx+1,sy,atb,ansibox[num].name);	// Print title

}


//
// Write a string to the screen
// at X,Y and with preset attribute
//

void wstring (x,y,att,string)
char x,y,att;
char *string;
{
	char far *scrn;
	int i,j;

	i=strlen(string);

	for (j=0; j<i; j++){
		scrn = vidmem + (x+j)*2 + (y*160);
		*scrn++=*string++;
		*scrn=att;
		}
}

//
// Write a string, centered on the screen
//

void cstring (y,att,string)
char att,y;
char *string;
{
	int len,x;

	len =(strlen(string))/2;
	x = 39-len;

	wstring (x,y,att,string);

}

//
// Clear a predefined box by replacing its background
// and resetting its menu/text pointer
//

void close_box(num)
char num;
{
	char i,j,x,y,h,w;
	char far *scrn;
	unsigned char *p;

	x = ansibox[num].x;		// Get details
	y = ansibox[num].y;
	h = ansibox[num].h;
	w = ansibox[num].w;
	p = ansibox[num].p;


	h++;			      	// Again, compensate for shadow
	w++;

	for (i=0; i<=h; i++)
		for (j=0; j<=w; j++) {
			scrn = vidmem + ((x+j)*2) + ((y+i)*160);

			*scrn++=*p++;
			*scrn=*p++;
			}
}

//
// Single Select call - auto determines between scrolling and normal
//

int select (num,attr)
char num,attr;
{

	int sel;

	if (ansibox[num].scroll){
		sel = sel_long_item(num,attr);
		return (sel);
		}
	else    {
		sel = sel_item(num,attr);
		return (sel);
		}
}


//
// Select a menu/text item using the up/dn cursors, RETURN key
// When exited, will return (i) menu/text item #, or (ii) -1 if ESC pressed
//

int sel_item (num, attr)
char num, attr;
{
	char posy,cx,cy,oldatt,limit;
	char **menitems;
	union inkey {
		char ch[2];
		int i;
		} c;

	cx = (ansibox[num].x) + 1;			// Get cursor position
	cy = (ansibox[num].y) + 1;
	oldatt = ansibox[num].att;
	menitems = ansibox[num].menu;			// Pointer to menu/text
	limit = (ansibox[num].num) - 1;

	posy = ansibox[num].ptr;       			// Last position of pointer

	wstring (cx,(cy+posy),attr,menitems[posy]); 	// Invert current item

	for(;;){ 					// Infinite FOR-loop

		while (!bioskey(1)); // Wait for keypress
		c.i = bioskey(0);

		wstring (cx,(cy+posy),oldatt,menitems[posy]);	// Un-invert item

		if (c.ch[0]){  				// If normal keystroke
			switch(c.ch[0]){

				case '\r': return posy; // Return
				case ' ' : posy++;      // Space bar
					   break;
				case ESC : return -1;   // Escape (-1 = no selection)

				}
			}
		else {   				// If special keypress
			switch(c.ch[1]){

				case 0x48 : posy --;  	// Up arrow
					    break;
				case 0x50 : posy ++;  	// Down Arrow
					    break;
				case 0x4d : posy ++;  	// Left arrow as for down
					    break;
				case 0x4b : posy --; 	// Right arrow as for up
					    break;

				}
			}
		if (posy < 0)				// Check for boundaries
			posy = 0;
		if (posy > limit)
			posy = limit;

		ansibox[num].ptr = posy;        	// Update pointer

		wstring (cx,(cy+posy),attr,menitems[posy]);	// Invert new item
		}
	}

//
// SCROLLING BOX - FOR LARGE LISTS !
// Select an menu/text item using the pgup/pgdn & cursors, RETURN key
// When exited, will return (i) menu/text item #, or (ii) -1 if ESC pressed
//

int sel_long_item (num, attr)
char num, attr;
{
	char posy,cx,cy,oldatt,max,limit,ty,height;
	char **menitems;

	union REGS r;

	union inkey {
		char ch[2];
		int i;
		} c;

	cx = (ansibox[num].x) + 1;			// Get cursor position
	cy = (ansibox[num].y) + 1;
	oldatt = ansibox[num].att;
	menitems = ansibox[num].menu;			// Pointer to menu/text
	limit = ansibox[num].num -1;
	max = ansibox[num].max;
	posy = ansibox[num].ptr;       			// Last position of pointer
	ty = ansibox[num].item;
	height = limit+1;

	wstring (cx,(cy+posy),attr,menitems[ty]); 	// Invert current item

	for(;;){ 					// Infinite FOR-loop

		while (!bioskey(1)); // Wait for keypress
		c.i = bioskey(0);

		wstring (cx,(cy+posy),oldatt,menitems[ty]);	// Un-invert item

		if (c.ch[0]){  				// If normal keystroke
			switch(c.ch[0]){

				case '\r': return ty;   // Return
				case ' ' : posy++;      // Space bar
					   ty++;
					   break;
				case ESC : return -1;   // Escape (-1 = no selection)

				}
			}
		else {   				// If special keypress
			switch(c.ch[1]){

				case 0x48 : posy --;  	// Up arrow
					    ty--;
					    break;
				case 0x50 : posy ++;  	// Down Arrow
					    ty++;
					    break;
				case 0x4d : posy ++;  	// Left arrow as for down
					    ty++;
					    break;
				case 0x4b : posy --; 	// Right arrow as for up
					    ty--;
					    break;

				case 0x51 : if ((ty+height)<max){	// Page down
							ty+=height;
							if ((ty+limit)>max){
								posy=limit;
								ty=max;
								}
							}
						else {
							ty=max;
							posy=limit;
							}

						ansibox[num].ptr=posy;
						ansibox[num].item=ty;
						draw_box(num);
						break;

				case 0x49 : if ((ty-height)>0){		// Page up
							ty-=height;
							if (ty<=limit)
								posy=ty;
							}
						else {
							ty=0;
							posy=0;
							}

						ansibox[num].ptr=posy;
						ansibox[num].item=ty;
						draw_box(num);
						break;
				default	: break;

				}
			}
		if (posy < 0 && ty < 0){		// Check for boundaries
			posy = 0;
			ty = 0;
			}

		if (posy > limit && ty > max){
			posy = limit;
			ty = max;
			}

		if (posy < 0 && ty >= 0){		// Scroll up if req'd

			posy = 0;

			r.h.al = 1;
			r.h.ch = cy;
			r.h.cl = cx;
			r.h.dh = cy + (ansibox[num].h - 2);
			r.h.dl = cx + (ansibox[num].w - 2);
			r.h.bh = oldatt;
			r.h.ah = 7;
			int86 (0x10, &r, &r);

			}

		if (posy > limit && ty <= max){		// Scroll down if req'd

			posy = limit;

			r.h.al = 1;
			r.h.ch = cy;
			r.h.cl = cx;
			r.h.dh = cy + (ansibox[num].h - 2);
			r.h.dl = cx + (ansibox[num].w - 2);
			r.h.bh = oldatt;
			r.h.ah = 6;
			int86 (0x10, &r, &r);

			}

		ansibox[num].ptr = posy;        		// Update pointers
		ansibox[num].item = ty;

		wstring (cx,(cy+posy),attr,menitems[ty]);	// Invert new item
		}
	}






