//
// Kevs comms routines header and macros
// 7 June 1993, (c)Kevin Phillips
//

#include <dos.h>

// First, define all registers for coms ports 1/2/3/4

#define MODDAT1 0x03f8	// Data register
#define MODMST1 0x03fe	// Modem status
#define LNESTA1 0x03fd	// Line status
#define MODCOM1 0x03fc	// Modem command register
#define MODIIR1 0x03fa	// Modem IIR
#define MODINT1 0x03f9	// Interrupt flag

#define MODDAT2 0x02f8
#define MODMST2 0x02fe
#define LNESTA2 0x02fd
#define MODCOM2 0x02fc
#define MODIIR2 0x02fa
#define MODINT2 0x02f9

#define MODDAT3 0x03e8
#define MODMST3 0x03ee
#define LNESTA3 0x03ed
#define MODCOM3 0x03ec
#define MODIIR3 0x03ea
#define MODINT3 0x03e9

#define MODDAT4 0x02e8
#define MODMST4 0x02ee
#define LNESTA4 0x02ed
#define MODCOM4 0x02ec
#define MODIIR4 0x02ea
#define MODINT4 0x02e9

// Define Configuration bits (Add together to get Configuration byte)

#define BPS0300 0x40
#define BPS1200 0x80
#define BPS2400 0xa0
#define BPS4800	0xc0
#define BPS9600	0xe0

#define PARN    0
#define PARO	8
#define PARE	0x18

#define STP1	0
#define STP2	4

#define DATA7	2
#define DATA8	3

// Define COMS Interrupt details

#define INTVEC2 0x0b	// These are Interrupt NUMBERS, not VECTOR address!
#define INTVEC1 0x0c    // (vector = 2c, number = 0b (vector = 4 x number))

// The reason is that the C interrupt construct works on the number.

#define ENABLE1	0x0ef   // Enable 8259 IQR4
#define ENABLE2 0x0f7	//   "      "  IQR3
#define DISABL2 0x008	// Disable  "  IQR3
#define DISABL1 0x010	//   "	    "  IQR4

#define INTCONT	0x021

// Define some constants

#define BUFFSIZ	10000
#define FALSE 0
#define TRUE  1


// Define GLOBAL variables for set-up editing

extern int moddata;	// Data register
extern int modcomd;	// Command register
extern int modint;	// Interrupt register
extern int linestat;    // Line status
extern int modstat;	// Modem status
extern int modiir;	// Modem IIR
extern int lnctrl;	// Line control

extern int ena8259;	// Enable mask
extern int dis8259;	// Disable mask

extern char intv;	// Address of vector

extern char *buffer;	// Buffer
extern int inptr;		// Pointer to insert new data
extern int outptr;		// Current read data

extern unsigned char configuration;	// Line configuration

extern char myport;		// Selected port

// Globals for functions

void hangupmodem(int);
void ser_init();
void set_interrupt();
void send_char(unsigned char);
extern int rec_char();
extern int key_press();
void set_com();



