//
// BTERM menus configuration
//

#include "globals.h"

// Define GLOBAL variables for KCOMM

int moddata;	// Data register
int modcomd;	// Command register
int modint;	// Interrupt register
int linestat;   // Line status
int modstat;	// Modem status
int modiir;	// Modem IIR

int ena8259;	// Enable mask
int dis8259;	// Disable mask

char intv;	// Address of vector
char *buffer;	// Buffer
int inptr;		// Pointer to insert new data
int outptr;		// Current read data

unsigned char configuration;	// Line configuration

char myport;		// Selected port

// Globals for Data set up

unsigned char speedb,parityb,stopb,datab;
char SNDFLG,btermquit,lecho,lnfeed,printerf;

// Define Menus

char *comstatm[]={
	"","   PORT   ",
	"","","   BAUD",
	"","","  PARITY",
	"","","   STOP",
	"","","   DATA","",""
	};
char *comportm[]={
	"COM1","COM2","COM3","COM4"
	};
char *speedm[]={
	" 300","1200","2400","4800","9600"
	};
char *paritym[]={
	"NONE","EVEN","ODD "
	};
char *stopm[]={
	"1 BIT","2 BIT"
	};
char *datam[]={
	"7 BIT","8 BIT"
	};
char *comeditm[]={
	" COMS   > "," BAUD   > "," PARITY > ",
	" STOPS  > "," DATA   > ",
	" SET/EXIT "
	};
char *exitbterm[]={
	"    YES     ","     NO     "
	};
char *hangupm[]={
	"     YES      ","      NO      "
	};
char *lechom[]={
	"    OFF     ","     ON     "
	};
char *lnfdm[]={
	"   OFF    ","    ON    "
	};
char *prntm[]={
	"  OFF   ","   ON   "
	};
char *hangmodem[]={
	"HANGING UP"
	};
char *instm[]={
	"","","","","","","","","","","","","","","","",
	"","","","","","",""
	};
char *pawse[]={
	"PAUSED"
	};
char *confbterm[]={
	"     COMS SETUP     ","   COLOUR & SOUND   ",
	"  SAVE DIALING DIR  "," SAVE SETUP TO DISC "
	};
char *btcsm[]={
	"","","","","","","","","","",""
	};
char *wdem[]={
	" ITEM",""
	};
char *fdem[]={
	"ITEM"
	};
char *pdm[]={
	"  ITEM"
	};
char *attmenm[]={
	" WINDOWS    "," MENUS      ",
	" PULL DOWNS "," FLAG MENUS ",
	" SELECTOR   "," SOUND      ",
	" EXIT       "
	};
char *allcolm[]={
	"BLU","BLK","RED","MAG","GRN","BWN","CYN","LGY",
	"BBL","DGY","BRD","BMG","BGN","YEL","BCN","WHT"
	};
char *bckcolm[]={
	"BLU","BLK","RED","MAG","GRN","BWN","CYN","LGY"
	};
char *whichcm[]={
	"FORE  >","BACK  >","BLINK >"
	};
char *onoffm[]={
	"OFF","ON "
	};
char *bcwinm[]={
	"BORDER","WINDOW"
	};
char *obdwnm[]={
	"BORDER","WINDOW"," TEXT "
	};
char *dialdir[]={
	"DIAL ","EDIT ","CLEAR"
	};
char *editdir[]={
	"","NAME:","                     ","","NUMBER:","",
	"","BAUD:","","","DATA:","",
	"","STOP:","","","PARITY:","",
	""
	};
unsigned char allattributes[]={
	BLU,BLK,RED,MAG,GRN,BRN,CYN,LGY,
	BLU + 8,BLK + 8,RED + 8,MAG + 8,
	GRN + 8,BRN + 8,CYN + 8,LGY + 8
	};
unsigned char attributes[]={
	BLU BAK,BLK BAK,RED BAK,MAG BAK,GRN BAK,BRN BAK,CYN BAK,LGY BAK
	};

// Define Desktop Colours

unsigned char INFWIN,INFBDR,INFTXT,MENWIN,MENBDR,PDNWIN;
unsigned char PDNBDR,FLGWIN,FLGBDR,SELCUR,SCRCOL;

// Define variables for ANSIBX

char far *vidmem;

DETAILS ansibox[32];

// Define modem control strings

char modemcontrolstring[30];
char dialstring[8];
char hangupstring[8];
char autoanswer[8];
char numbertodial[15];

char dialtime;
char redial;

// Define dial directory arrays

char dialname[20];	// Temporary storage
char dialnumber[15];
unsigned char dialspeed;
unsigned char dialdata;
unsigned char dialstop;
unsigned char dialparity;

char *listing[]={	// Main directory listing
	"000  NAMEOFUPTOTWENTYCHAR  0000-0000-00000  00 dps",
	"001                                               ",
	"002                                               ",
	"003                                               ",
	"004                                               ",
	"005                                               ",
	"006                                               ",
	"007                                               ",
	"008                                               ",
	"009                                               ",
	"010                                               ",
	"011                                               ",
	"012                                               ",
	"013                                               ",
	"014                                               ",
	"015                                               ",
	"016                                               ",
	"017                                               ",
	"018                                               ",
	"019                                               ",
	"020                                               ",
	"021                                               ",
	"022                                               ",
	"023                                               ",
	"024                                               ",
	"025                                               ",
	"026                                               ",
	"027                                               ",
	"028                                               ",
	"029                                               ",
	"030                                               ",
	"031                                               ",
	"032                                               ",
	"033                                               ",
	"034                                               ",
	"035                                               ",
	"036                                               ",
	"037                                               ",
	"038                                               ",
	"039                                               ",
	"040                                               ",
	"041                                               ",
	"042                                               ",
	"043                                               ",
	"044                                               ",
	"045                                               ",
	"046                                               ",
	"047                                               ",
	"048                                               ",
	"049                                               ",
	"050                                               ",
	"051                                               ",
	"052                                               ",
	"053                                               ",
	"054                                               ",
	"055                                               ",
	"056                                               ",
	"057                                               ",
	"058                                               ",
	"059                                               ",
	"060                                               ",
	"061                                               ",
	"062                                               ",
	"063                                               ",
	"064                                               ",
	"065                                               ",
	"066                                               ",
	"067                                               ",
	"068                                               ",
	"069                                               ",
	"070                                               ",
	"071                                               ",
	"072                                               ",
	"073                                               ",
	"074                                               ",
	"075                                               ",
	"076                                               ",
	"077                                               ",
	"078                                               ",
	"079                                               ",
	"080                                               ",
	"081                                               ",
	"082                                               ",
	"083                                               ",
	"084                                               ",
	"085                                               ",
	"086                                               ",
	"087                                               ",
	"088                                               ",
	"089                                               ",
	"090                                               ",
	"091                                               ",
	"092                                               ",
	"093                                               ",
	"094                                               ",
	"095                                               ",
	"096                                               ",
	"097                                               ",
	"098                                               ",
	"099                                               ",
	};

